"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.registerScenarioDiagnostics = void 0;
const vscode = require("vscode");
const yaml = require("js-yaml");
function registerScenarioDiagnostics(context) {
    const collection = vscode.languages.createDiagnosticCollection('scenarioLint');
    context.subscriptions.push(vscode.workspace.onDidSaveTextDocument(doc => {
        if (doc.languageId === 'yaml' && doc.fileName.endsWith('.scenario.yml')) {
            const diagnostics = [];
            try {
                yaml.load(doc.getText());
            }
            catch (err) {
                const range = new vscode.Range(0, 0, 0, 1);
                diagnostics.push(new vscode.Diagnostic(range, `YAMLエラー: ${err.message}`, vscode.DiagnosticSeverity.Error));
            }
            collection.set(doc.uri, diagnostics);
        }
    }));
}
exports.registerScenarioDiagnostics = registerScenarioDiagnostics;
//# sourceMappingURL=scenario-diagnostics.js.map