"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.exportToText = void 0;
function exportToText(scenario) {
    const lines = [];
    lines.push(`# ${scenario.title}`);
    lines.push('');
    scenario.characters.forEach(char => {
        lines.push(`## キャラクター: ${char.name}`);
        lines.push(`- ID: ${char.id}`);
        if (char.gender)
            lines.push(`- 性別: ${char.gender}`);
        if (char.age)
            lines.push(`- 年齢: ${char.age}`);
        if (char.occupation)
            lines.push(`- 職業: ${char.occupation}`);
        lines.push('');
    });
    scenario.scenes.forEach(scene => {
        lines.push(`# シーン${scene.id}: ${scene.name}`);
        if (scene.time_of_day)
            lines.push(`時間帯: ${scene.time_of_day}`);
        if (scene.description)
            lines.push(`説明: ${scene.description}`);
        if (scene.tags.length)
            lines.push(`タグ: ${scene.tags.join(', ')}`);
        lines.push('');
        scene.cuts.forEach(cut => {
            lines.push(`- カット${cut.id}:`);
            if (cut.camera.angle)
                lines.push(`  カメラ: ${cut.camera.angle}`);
            if (cut.action)
                lines.push(`  アクション: ${cut.action}`);
            cut.dialogue.forEach(dialog => {
                lines.push(`  ${dialog.speaker}: 「${dialog.text}」`);
            });
            lines.push('');
        });
        lines.push('');
    });
    return lines.join('\n');
}
exports.exportToText = exportToText;
//# sourceMappingURL=scenario-exporter.js.map