"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.countTotalDurationFromText = void 0;
const yaml = require("js-yaml");
function countTotalDurationFromText(text) {
    let yamlData;
    try {
        yamlData = yaml.load(text);
    }
    catch (err) {
        throw new Error('YAMLのパースに失敗しました。');
    }
    if (!yamlData?.sequences) {
        throw new Error('YAML構造が不正です。sequencesが見つかりません。');
    }
    let total = 0;
    for (const seq of yamlData.sequences) {
        if (!seq?.scenes)
            continue;
        for (const scene of seq.scenes) {
            if (!scene?.cuts)
                continue;
            for (const cut of scene.cuts) {
                const duration = cut?.duration;
                if (typeof duration === 'number') {
                    total += duration;
                }
            }
        }
    }
    return total;
}
exports.countTotalDurationFromText = countTotalDurationFromText;
//# sourceMappingURL=countTotalDuration.js.map