"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.promptSequenceAndSceneRange = void 0;
const vscode = require("vscode");
const parseRangeInput_1 = require("./parseRangeInput");
async function promptSequenceAndSceneRange(minSeq, maxSeq) {
    const sequenceRangeInput = await vscode.window.showInputBox({
        prompt: "シーケンス範囲を入力（例: 1-3、2-、-5、-）"
    });
    const sceneRangeInput = await vscode.window.showInputBox({
        prompt: "シーン範囲を入力（例: 1-5、2-、-4、-）"
    });
    try {
        const sequenceRange = (0, parseRangeInput_1.parseRangeInput)(sequenceRangeInput, minSeq, maxSeq);
        const sceneRange = (0, parseRangeInput_1.parseRangeInput)(sceneRangeInput, 1, 9999);
        return { sequenceRange, sceneRange };
    }
    catch (e) {
        vscode.window.showErrorMessage(e.message);
        return null;
    }
}
exports.promptSequenceAndSceneRange = promptSequenceAndSceneRange;
//# sourceMappingURL=inputRange.js.map