"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseRangeInput = void 0;
function parseRangeInput(input, min, max) {
    if (!input || input.trim() === '-')
        return [min, max];
    const match = input.match(/^(\d*)-(\d*)$/);
    if (!match) {
        throw new Error("範囲の形式が不正です。例: 1-3、2-、-5、-");
    }
    const start = match[1] ? parseInt(match[1], 10) : min;
    const end = match[2] ? parseInt(match[2], 10) : max;
    if (isNaN(start) || isNaN(end) || start > end) {
        throw new Error("開始値と終了値の指定が不正です。");
    }
    return [start, end];
}
exports.parseRangeInput = parseRangeInput;
//# sourceMappingURL=parseRangeInput.js.map