"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseYamlWithFeedback = void 0;
const yaml = require("js-yaml");
const vscode = require("vscode");
/**
 * YAML文字列をパースし、パースエラーがあれば内容・位置を表示＋ジャンプ
 */
function parseYamlWithFeedback(text) {
    try {
        return yaml.load(text);
    }
    catch (e) {
        if (e.mark) {
            const line = e.mark.line;
            const col = e.mark.column;
            const message = `記述にエラーがあります:（${line + 1}行目, ${col + 1}文字目）: ${e.message}`;
            vscode.window.showErrorMessage(message);
            const editor = vscode.window.activeTextEditor;
            if (editor) {
                const pos = new vscode.Position(line, col);
                editor.selection = new vscode.Selection(pos, pos);
                editor.revealRange(new vscode.Range(pos, pos));
            }
        }
        else {
            vscode.window.showErrorMessage(`記述にエラーがあります: ${e.message}`);
        }
        return undefined;
    }
}
exports.parseYamlWithFeedback = parseYamlWithFeedback;
//# sourceMappingURL=parseYamlWithFeedback.js.map