# 🎬 ScreenPlay Formater for VSCode

バージョン: 0.7.0

映画・アニメ・ボイスドラマ・その他なんでも、シナリオ作成支援VSCode拡張機能 
シーケンス → シーン → カット の階層構造で、プロフェッショナルなシナリオ管理が可能になります。
『ルールを知らない者はルールを破れない。』

---

## 🛠 インストール方法

1. `ScreenPlay Formater-xxx.vsix` をダウンロード
2. ターミナルまたはコマンドパレットで以下を実行

```bash
code --install-extension ScreenPlay Formater-xxx.vsix
```

---
## 「YAML by Red Hat」のインストール

本拡張機能に加えて「YAML by Red Hat」のインストールを行ってだい。
「YAML by Red Hat」は、YAMLのエラーチェックやコードハイライト、補完機能を持ちます。

---

## 🚀 使い方の流れ

1. Ctrl + Shift + P でコマンドパレットを開く
コマンド名	説明
sp.createNewFile	新規ファイル
sp.addTemplate	テンプレート追加
sp.addSequences	シーケンス追加
sp.addScene	シーン追加
sp.addCut	カット追加
sp.previewScene	プレビュー
sp.countTotalDuration	総尺カウント（範囲指定対応）
sp.countDialogueCharacters	セリフ文字数カウント（範囲指定対応）
sp.exportHtml	HTML書き出し

---

## 🎥 デモ動画

（ここにGIFアニメを貼る予定）

例：

```markdown
![ScreenPlay Formater for VSCode](https://github.com/buzzlyhan/screenplay-formater/raw/HEAD/images/demo.gif)
```

※ `images/` フォルダに `demo.gif` を置いてください！

---

## 🧩 今後の予定

- プレビュー画面のツリー表示強化
- YAML構造自動Lint機能
- 新規シナリオ作成テンプレートの拡充
- AIとの連携による動画生成支援

---

## ❓ FAQ

- **Q: ファイル名は？**
  - A: `xxxx.sp.yml` 形式で保存してください。

---

## 📝 主要フィールド一覧（完全版）

| フィールド | 日本語訳 | 説明 |
|:----------|:---------|:----|
| title | 作品タイトル | シナリオ全体のタイトル |
| authors | 著者リスト | シナリオの著者名（複数可） |
| created_at | 作成日 | シナリオが作成された日付（ISO形式） |
| updated_at | 更新日 | 最終更新された日付（ISO形式） |
| version | バージョン | シナリオのバージョン番号 |
| description | 説明 | 流れ、場面、カットの簡単な説明 |
| repository | リポジトリURL | 最新版が格納されているGitHub等のURL |
| sequences | シーケンス | 物語の流れの単位、複数シーンをまとめる |
| name | 名前 | シーケンス名・シーン名・カット名に使用 |
| scenes | シーンリスト | シーケンス内に含まれる場面のリスト |
| id | ID | 一意にシーンやカットを識別する番号 |
| duration | 時間（秒） | シーンまたはカットの再生時間（秒単位、null可） |
| time_of_day | 時間帯 | 朝、昼、夕方、夜など場面の時間設定 |
| se | サウンドエフェクト | 効果音（例：BGM、環境音） |
| actors | 登場人物リスト | シーン内で登場するキャラクター一覧 |
| cuts | カットリスト | シーン内を構成するショットのリスト |
| camera | カメラ設定 | ショットにおけるカメラのアングル・動き |
| action | 動作 | キャラクターやカメラの動作説明 |
| dialogue | セリフリスト | セリフの配列（speakerとtextを持つ） |
| speaker | セリフの話者 | dialogue内でセリフを話すキャラクター |
| text | セリフ本文 | 実際に話されるセリフ内容 |
| transition | トランジション | カット間の映像切替効果（フェード、オーバーラップなど） |


---

# 🧹 ScreenPlay Formatert（sp.yaml） 最新記述規則

---

## 1. キーと値の記述
- キーと値は必ずコロン（: ）で区切り、コロンの直後に半角スペースを入れます。

```yaml
title: "春の日の屋上"
```

---

## 2. リスト（配列）の書き方
- リストはキーの次に改行し、各要素の先頭にハイフン（- ）と半角スペースを入れます。

```yaml
actors:
  - "結城 翼"
  - "植田 彦"
```

---

## 3. インデントルール（重要）
- インデントは半角スペース純粋で統一し、階層ごとに次の数を使います：

| 階層 | 内容 | インデント幅 |
|:---|:---|:---|
| シーケンス（sequence） | 物語の大単位 | 半角スペース 2個 |
| シーン（scene） | シーケンス内の場面 | 半角スペース 6個 |
| カット（cut） | シーン内のショット単位 | 半角スペース 10個 |

- コマンド「sp: シーン追加」、「sp: カット追加」を使うと正しく位置合わせされます。
- インデント歪れはパースエラーの原因になります。

---

## 4. 空行について
- 行と行の間に空行を入れても問題ありません。
- 読みやすさを優先して適度に空けましょう。

---

## 5. 複数行文章（段落）の書き方
- 複数行のテキストはパイプ記号（`|`）を使って記述します。

```yaml
description: |
  春の日、卒業を探している生徒の物語
  友情、恋愛、夢を追いかける姿を描く。
```

---

## 6. コメントの書き方
- コメントはシャープ記号（#）を使います。

```yaml
# ここからシーケンス定義
sequences:
```

- データ構造に影響しないので、情報補補や指示に活用します。

---

## 7. 空フィールドの扱い
- 空の配列や値は `[]` や `null` を書かず、キーだけを置くようにします。

```yaml
se:
dialogue:
```

---

# ⬆️ 大事なこと

> sp.yamlでは「統一されたインデント」「正確なキーと値の記述」「可読性を意識した空行」が特に重要です。  
> 必ず拡張機能コマンド（sp: シーン追加、sp: カット追加）を活用して、ミスや構文エラーを防ぎましょう。


---

✅ **まとめ**  
改行は自由ですが、インデントだけは絶対に守ってください！



---

## 📄 ScreenPlay Formater 例

```yaml
title: "春の日の屋上"
authors:
  - "伊丹シゲユキ"
  - "山田太郎"
  - "佐藤花子"
# 書き手が足りないので共同執筆者を募集中です。

created_at: "2025-04-27"
updated_at: "2027-03-02"
version: "1.0"
description: |
  春の日、卒業を控えた生徒の物語
  友情、恋愛、夢を追いかける姿を描く。
  それぞれの思いが交差する瞬間を描く。

# 最新版のシナリオはgithubにアクセスしてください。
repository: "https://github.com/yourname/yourproject"

# 映像化とボイスドラマのためのシナリオです。
# アカデミー賞狙います🔥🔥🔥

sequences:
  - id: 1
    name: "春の出会い"
    description: "新学期、新しいクラスメイトとの出会いと始まり"

    scenes:
      - id: 1
        name: "始業式の朝"
        duration: 
        time_of_day: "朝"
        se: "チャイムの音、教室のざわめき"
        description: "新しい教室。生徒たちがざわざわと席に着く。"
        actors:
          - "結城 翼（主人公）"
          - "高橋 光（親友）"
          - "椎名 紗良（ヒロイン）"

        cuts:
          - id: 1
            camera: "教室全体のロングショット"
            description: "窓から朝日が差し込み、埃がきらめく教室。"
            se: 

            dialogue: 
            duration: 4
            transition: "フェードイン"

          - id: 2
            camera: "翼と光の中距離ショット"
            description: "隣同士に座る翼と光。どこか落ち着かない様子。"
            se: 

            dialogue:
              - speaker: "光"
                description: "机に肘をつきながら"
                text: "また同じクラスかよ、俺たち。"

              - speaker: "翼"
                description: "小さく笑いながら"
                text: "まあ、楽でいいけどな。"
                
            duration: 6
            transition: "カット"
  - id: 2
# 只今、会話調整中です。
    name: "静かな放課後"
    description: "交差する想い、誰にも見せない本音"

    scenes:
      - id: 1
        name: "放課後の図書室"
        duration: 
        time_of_day: "夕方"
        se: "ページをめくる音、遠くのチャイム"
        description: "陽が傾く図書室。静かに本を読む生徒たち。"
        actors:
          - "結城 翼"
          - "椎名 紗良"

        cuts:
          - id: 1
            camera: "図書室の俯瞰ショット"
            description: "棚の間にぽつんと座る紗良。光の粒が漂っている。"
            se: 

            dialogue: 
            duration: 5
            transition: "カット"

      - id: 2
        name: "校庭"
        duration: 
        time_of_day: "夕方"
        se: 
        description: "サッカー部が練習を続ける"
        actors: 
          - "結城 翼"
          - "椎名 紗良"

        cuts:
          - id: 1
            camera: "翼の視線からのショット"
            description: "本棚越しに紗良を見つめる翼。"
            se: 

            dialogue: 
            duration: 4
            transition: "カット"

          - id: 2
            camera: "翼と紗良のバストショット"
            description: "翼が本を手に紗良に近づく。少しだけためらいながら。"
            se: 

            dialogue:
              - speaker: "翼"
                description: "声をひそめて"
                text: "この本、面白いって聞いた。"

              - speaker: "紗良"
                description: "はにかみながら"
                text: "…うん、すごくいいよ。"

            duration: 7
            transition: "フェードアウト"

  - id: 3
    name: "未来への一歩"
    description: "進路発表、夢へ向かう決意"

    scenes:
      - id: 1
        name: "体育館での発表"
        duration: 
        time_of_day: "昼"
        se: "生徒たちのざわめき、マイクのハウリング音"
        description: "進路発表会。体育館に集まる生徒たち。"
        actors:
          - "結城 翼"
          - "椎名 紗良"
          - "高橋 光"
          - "教師たち"
          #カット割り案お願いします。

        cuts:
          - id: 1
            camera: "体育館全体のロングショット"
            description: "生徒たちが整列して座っている。ざわめきが次第に静まる。"
            se: 

            dialogue: 
            duration: 5
            transition: "フェードイン"

          - id: 2
            camera: "ステージ上の教師バストアップ"
            description: "マイクを手に進路発表の説明をする教師。"
            se: 
            
            dialogue: 
            duration: 4
            transition: "カット"

          - id: 3
            camera: "翼のクローズアップ"
            description: "拳を握りしめ、まっすぐ前を見つめる翼。"
            se: 

            dialogue:
              - speaker: "翼"
                description: "心の中で強く"
                text: "絶対に夢を叶える…！"

            duration: 6
            transition: "フェードアウト"
```
---

## 📜 ライセンス

MIT License

---

Created with ❤️ by buzzlyhan@gmail.com